//
// Created by bnozka on 25.08.2021.
//

#ifndef DWIPE_BEEP_H
#define DWIPE_BEEP_H

#include "TickableState.h"

#include <fcntl.h>
#include <unistd.h>

#include <linux/kd.h>
#include <linux/input.h>

class Beep: public TickableState {
public:
    Beep()
    {
        fd_beep = open("/dev/tty0", O_WRONLY);
    }
    ~Beep()
    {
        ioctl(fd_beep, KIOCSOUND, 0);
        close(fd_beep);
    }

    void tick() final
    {
        ioctl(fd_beep, KIOCSOUND, c_note);
        std::this_thread::sleep_for(std::chrono::milliseconds(200));
        ioctl(fd_beep, KIOCSOUND, g_note);
        std::this_thread::sleep_for(std::chrono::milliseconds(200));
        ioctl(fd_beep, KIOCSOUND, e_note);

        std::this_thread::sleep_for(std::chrono::milliseconds(200));
        ioctl(fd_beep, KIOCSOUND, 0);

        std::this_thread::sleep_for(std::chrono::seconds (2));
    };
    void abort() final { ioctl(fd_beep, KIOCSOUND, 0);};
private:
    int fd_beep;

    static constexpr unsigned long int c_note = (1193180.0/(261.626));
    static constexpr unsigned long int e_note = (1193180.0/(329.628));
    static constexpr unsigned long int g_note = (1193180.0/(391.995));
};

#endif //DWIPE_BEEP_H
