//
// Created by bnozka on 30.05.2021.
//

#ifndef DWIPE_BUFFERSIZECHECKER_H
#define DWIPE_BUFFERSIZECHECKER_H

#include <chrono>

#include "TickableState.h"

class BufferSizeChecker : public TickableState {
public:
    explicit BufferSizeChecker(const std::filesystem::path& path, unsigned int& buffer_size);
    void tick() final;
    void reset() final;
    void abort() final;

    [[nodiscard]] unsigned int getCurrentBufferSize() const { return current_buffer_size; };
private:
    enum
    {
        INIT,
        NEXT_BUFFER,
        WRITING,
    } state{INIT};

    static constexpr std::chrono::milliseconds writing_duration{200};

    const std::filesystem::path& path;
    unsigned int& final_buffer_size;

    int file_descriptor{};
    unsigned int current_buffer_size{block_size};
    unsigned long current_writen{};
    unsigned long last_writen{};
    std::chrono::high_resolution_clock::time_point start{};
};

#endif //DWIPE_BUFFERSIZECHECKER_H
