//
// Created by bnozka on 30.05.2021.
//

#ifndef DWIPE_TICKABLESTATE_H
#define DWIPE_TICKABLESTATE_H

#include <filesystem>

class TickableState {
public:
    enum State
    {
        RUNNING,
        FINISH,
        ERROR
    };

    virtual void tick() = 0;
    virtual void reset() { tickable_state = RUNNING; };
    virtual void abort() = 0;

    [[nodiscard]] State getState() const { return tickable_state; };
    [[nodiscard]] int getLastError() const { return last_error; };
protected:
    int last_error{};
    State tickable_state{RUNNING};
    static const unsigned char* const buffer;
    static constexpr unsigned int block_size{512};
    static constexpr unsigned int max_buffer_size{16777216};
};

#endif //DWIPE_TICKABLESTATE_H
