//
// Created by bnozka on 30.05.2021.
//

#ifndef DWIPE_ZEROWRIER_H
#define DWIPE_ZEROWRIER_H

#include "TickableState.h"

class ZeroWriter: public TickableState {
public:
    ZeroWriter(const std::filesystem::path& path, const unsigned int& buffer_size, unsigned long size);
    void tick() final;
    void reset() final;
    void abort() final;

    [[nodiscard]] unsigned long getWriten() const { return current_writen; };
    [[nodiscard]] unsigned long getSize() const { return dev_size; };
    [[nodiscard]] unsigned int getSpeed() const { return speed; };
private:
    enum
    {
        INIT,
        WRITING,
    } state{INIT};
    static constexpr std::chrono::milliseconds writing_duration{250};
    static constexpr double long lpf_beta {0.05};

    const std::filesystem::path& path;
    const unsigned int& buffer_size;
    const unsigned long dev_size;

    int file_descriptor{};
    unsigned long current_writen{};
    double long speed{};
    std::chrono::high_resolution_clock::time_point start{};
    unsigned long last_writen{};
};

#endif //DWIPE_ZEROWRTER_H
